/**************************************************************
*
*                MIDI.H
*
**************************************************************/

typedef unsigned char event ; /* MIDI event */

#define MSN            0xF0 /* most significant nibble */
#define LSN            0x0F /* least significant nibble */

#define STATUS         0x80 /* most significant bit set in status byte */
#define NOTE_ON        0x90 /* note on status nibble */
#define NOTE_OFF       0x80 /* note off status nibble */
#define POLY_KEY_PRESS 0xA0 /* polyphonic key pressure status nibble */
#define CHANNEL_PRESS  0xD0 /* channel pressure status nibble */
#define PROGRAM_CHANGE 0xC0 /* program change status nibble */

#define CONTROL_CHANGE 0xB0 /* controller change status nibble */
#define SUSTAIN          64 /* controller number for sustain pedal */
#define ALL_NOTES_OFF   123 /* controller number for "all notes off" */

#define PITCH_BEND     0xE0 /* pitch bend status nibble */
#define MIN_PITCH    0x0000 /* pitch bend min. position */
#define MAX_PITCH    0x3FFF /* pitch bend max. position */
#define MEAN_PITCH   0x2000 /* pitch bend in center position */

#define SYS_EX         0xF0 /* system exclusive transmit F0 */
#define SYS_EX_NT      0xF7 /* system exclusive not transmit F0 */

#define META_EVENT     0xFF /* meta event */
#define SQ_TRCK_NAME   0x03 /* sequence or track name */
#define END_OF_TRACK   0x2F
